-- XXX TODO
-- * Unfuck the DB variables, all those globals are screwing with my mind.

local addonName = ...
local guildName = nil
local db = nil
local guildMaster = nil
local pName = UnitName("player")

local today = nil
local sessionTotal = 0
local allTimeTotal = nil
local lastTransmitTime = nil

local color = "|cffffffff"
local sysColor = "|cffffffff"

------ Locale
local L_NAME = "Guild Money"
local L_SESSION = "This session"
local L_WEEK = "Last 7 days"
local L_MONTH = "Last 30 days"
local L_ALLTIME = "All time total"
local L_NOINCOME = "You haven't generated any income to your guild for the past month - stop slacking!"
local L_NOINCOME_GM = "You haven't generated any income to your guild for the past month - stop slacking! %s is very disappointed."
local L_GOODBOY = "Good boy. Once you provide some more income, daddy will give you something special!"
local L_GOODBOY_GM = "Good boy. Once you provide some more income, daddy %s will give you something special!"
local L_MAINCHAR = "%s Your main character is %s."
local L_TOPFIVE = "Top 5 contributors"
local L_SET_HEADER = "Set main character"
local L_SET_BODY = "Please set which character in %s<%s>|r is your main, so that when you distribute your total earned to the rest of the guild they see all your efforts combined, and not per-character. If you don't provide a character name here, you will be reminded again later."
local L_SET_SET = "Set main"
local L_SET_LATER = "Do it later"
local L_SET_MESSAGE = "%sYour main character for |r%s<%s>|r%s has been set to %q. If you want to change this, you can use the command /bgmmain to change it at a later point.|r"
local L_SET_NOTSET = "%sYou need to set your main character if you want to distribute your earnings to the rest of the guild. Use /bgmmain to do so at a later point. You will be reminded again next session.|r"
------
local queryForMainCharacter
do
	local window = nil
	local function closeNoSave()
		print(L_SET_NOTSET:format(sysColor))
		window:Hide()
	end
	function queryForMainCharacter()
		if window then
			window:Show()
			return
		end
		window = CreateFrame("Frame", nil, UIParent)
		window:SetWidth(260)
		window:SetHeight(220)
		window:SetPoint("CENTER")
		window:SetMovable(true)
		window:EnableMouse(true)
		window:SetClampedToScreen(true)
		window:RegisterForDrag("LeftButton")
		window:SetScript("OnDragStart", window.StartMoving)
		window:SetScript("OnDragStop", window.StopMovingOrSizing)

		local titlebg = window:CreateTexture(nil, "BACKGROUND")
		titlebg:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Title-Background")
		titlebg:SetPoint("TOPLEFT", 9, -6)
		titlebg:SetPoint("BOTTOMRIGHT", window, "TOPRIGHT", -28, -24)

		local dialogbg = window:CreateTexture(nil, "BACKGROUND")
		dialogbg:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
		dialogbg:SetPoint("TOPLEFT", 8, -24)
		dialogbg:SetPoint("BOTTOMRIGHT", -6, 8)
		dialogbg:SetVertexColor(0, 0, 0, .75)

		local topleft = window:CreateTexture(nil, "BORDER")
		topleft:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
		topleft:SetWidth(64)
		topleft:SetHeight(64)
		topleft:SetPoint("TOPLEFT")
		topleft:SetTexCoord(0.501953125, 0.625, 0, 1)

		local topright = window:CreateTexture(nil, "BORDER")
		topright:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
		topright:SetWidth(64)
		topright:SetHeight(64)
		topright:SetPoint("TOPRIGHT")
		topright:SetTexCoord(0.625, 0.75, 0, 1)

		local top = window:CreateTexture(nil, "BORDER")
		top:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
		top:SetHeight(64)
		top:SetPoint("TOPLEFT", topleft, "TOPRIGHT")
		top:SetPoint("TOPRIGHT", topright, "TOPLEFT")
		top:SetTexCoord(0.25, 0.369140625, 0, 1)

		local bottomleft = window:CreateTexture(nil, "BORDER")
		bottomleft:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
		bottomleft:SetWidth(64)
		bottomleft:SetHeight(64)
		bottomleft:SetPoint("BOTTOMLEFT")
		bottomleft:SetTexCoord(0.751953125, 0.875, 0, 1)

		local bottomright = window:CreateTexture(nil, "BORDER")
		bottomright:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
		bottomright:SetWidth(64)
		bottomright:SetHeight(64)
		bottomright:SetPoint("BOTTOMRIGHT")
		bottomright:SetTexCoord(0.875, 1, 0, 1)

		local bottom = window:CreateTexture(nil, "BORDER")
		bottom:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
		bottom:SetHeight(64)
		bottom:SetPoint("BOTTOMLEFT", bottomleft, "BOTTOMRIGHT")
		bottom:SetPoint("BOTTOMRIGHT", bottomright, "BOTTOMLEFT")
		bottom:SetTexCoord(0.376953125, 0.498046875, 0, 1)

		local left = window:CreateTexture(nil, "BORDER")
		left:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
		left:SetWidth(64)
		left:SetPoint("TOPLEFT", topleft, "BOTTOMLEFT")
		left:SetPoint("BOTTOMLEFT", bottomleft, "TOPLEFT")
		left:SetTexCoord(0.001953125, 0.125, 0, 1)

		local right = window:CreateTexture(nil, "BORDER")
		right:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
		right:SetWidth(64)
		right:SetPoint("TOPRIGHT", topright, "BOTTOMRIGHT")
		right:SetPoint("BOTTOMRIGHT", bottomright, "TOPRIGHT")
		right:SetTexCoord(0.1171875, 0.2421875, 0, 1)

		local close = CreateFrame("Button", nil, window, "UIPanelCloseButton")
		close:SetPoint("TOPRIGHT", 2, 1)
		close:SetScript("OnClick", closeNoSave)

		local title = window:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		title:SetAllPoints(titlebg)
		title:SetJustifyH("CENTER")
		title:SetText("Broker: Guild Money")

		local header = window:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
		header:SetPoint("TOPLEFT", 16, -32)
		header:SetPoint("TOPRIGHT", -16, -32)
		header:SetJustifyH("LEFT")
		header:SetText(L_SET_HEADER)

		local later = CreateFrame("Button", "BGMSetLater", window, "UIPanelButtonTemplate2")
		later:SetHeight(32)
		later:SetWidth(100)
		later:SetText(L_SET_LATER)
		later:SetPoint("BOTTOMLEFT", window, "BOTTOMLEFT", 16, 16)
		later:SetScript("OnClick", closeNoSave)

		local editbox = nil

		local set = CreateFrame("Button", "BGMSetMainChar", window, "UIPanelButtonTemplate2")
		set:SetPoint("BOTTOMRIGHT", window, "BOTTOMRIGHT", -16, 16)
		set:SetPoint("RIGHT", window, "RIGHT", -16, 0)
		set:SetHeight(32)
		set:SetWidth(100)
		set:SetScript("OnClick", function()
			local input = editbox:GetText()
			if not input or input:trim():len() < 3 then
				closeNoSave()
			else
				db.mainChar = input
				print(L_SET_MESSAGE:format(sysColor, color, guildName, sysColor, db.mainChar))
				window:Hide()
			end
		end)
		set:SetText(L_SET_SET)

		editbox = CreateFrame("EditBox", nil, window, "InputBoxTemplate")
		editbox:SetPoint("LEFT", window, "LEFT", 22, 0)
		editbox:SetPoint("RIGHT", window, "RIGHT", -18, 0)
		editbox:SetPoint("BOTTOM", set, "TOP", 0, 8)
		editbox:SetHeight(20)
		editbox:SetText(db.mainChar or pName)

		local text = window:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
		text:SetPoint("TOPLEFT", header, "BOTTOMLEFT", 0, -4)
		text:SetPoint("BOTTOMRIGHT", editbox, "TOPRIGHT", 0, 4)
		text:SetJustifyH("LEFT")
		text:SetJustifyV("TOP")
		text:SetText(L_SET_BODY:format(color, guildName))
		
		window:Show()
	end
end

local function sortOnTotal(a, b)
	local aT = a == pName and allTimeTotal or db.others[a]
	local bT = b == pName and allTimeTotal or db.others[b]
	return aT > bT
end

local tmpSort = {}
local scoreFormat = "%d. %s"
local function getHint(added)
	local hint = guildMaster and L_NOINCOME_GM:format(guildMaster) or L_NOINCOME
	if added then
		hint = guildMaster and L_GOODBOY_GM:format(guildMaster) or L_GOODBOY
	end
	if db.mainChar then return L_MAINCHAR:format(hint, db.mainChar) end
	return hint
end
local function updateTooltip(tt)
	tt:AddLine(L_NAME)
	local added = nil
	if sessionTotal > 0 then
		tt:AddDoubleLine("This session", GetCoinTextureString(sessionTotal), 1, 1, 1, 0, 1, 0)
		added = true
	end
	if db.days[today] and db.days[today] > 0 then
		tt:AddDoubleLine(HONOR_TODAY, GetCoinTextureString(db.days[today]), 1, 1, 1, 0, 1, 0)
		added = true
	end
	local week = 0
	for i = today, (today - 7), -1 do
		week = week + (db.days[i] or 0)
	end
	if week > 0 then
		tt:AddDoubleLine(L_WEEK, GetCoinTextureString(week), 1, 1, 1, 0, 1, 0)
		added = true
	end
	local month = week
	for i = (today - 7), (today - 30), -1 do
		month = month + (db.days[i] or 0)
	end
	if month > 0 then
		tt:AddDoubleLine(L_MONTH, GetCoinTextureString(month), 1, 1, 1, 0, 1, 0)
		added = true
	end
	if allTimeTotal and allTimeTotal > 0 then
		tt:AddDoubleLine(L_ALLTIME, GetCoinTextureString(allTimeTotal), 1, 1, 1, 0, 1, 0)
		added = true
	end

	wipe(tmpSort)
	tmpSort[1] = pName
	for k, v in pairs(db.others) do
		tmpSort[#tmpSort + 1] = k
	end
	if #tmpSort > 1 then
		added = true
		table.sort(tmpSort, sortOnTotal)
		tt:AddLine(" ")
		tt:AddLine(L_TOPFIVE)
		for i, p in next, tmpSort do
			local v = p == pName and allTimeTotal or db.others[p]
			tt:AddDoubleLine(scoreFormat:format(i, p), GetCoinTextureString(v), 1, 1, 1, 0, 1, 0)
		end
	end
	tt:AddLine(" ")
	tt:AddLine(getHint(added), 0.2, 1, 0.2, 1)
end

local ldb = LibStub("LibDataBroker-1.1")
local bGuildMoney = ldb:NewDataObject("GuildMoney", {
	type = "data source",
	icon = "Interface\\MoneyFrame\\UI-GoldIcon",
	text = L_NAME,
})

local function updateText()
	local amount = db.days[today] or 0
	if amount == 0 then
		bGuildMoney.text = L_NAME
	else
		local gold = floor(math.abs(amount) / 10000)
		local silver = mod(floor(math.abs(amount) / 100), 100)
		local copper = mod(floor(math.abs(amount)), 100)
		if gold ~= 0 then
			bGuildMoney.text = format("%dg%ds%dc", gold, silver, copper)
		elseif silver ~= 0 then
			bGuildMoney.text = format("%ds%dc", silver, copper)
		else
			bGuildMoney.text = format("%dc", copper)
		end
	end
end

local matchGold = GOLD_AMOUNT:gsub("%%d", "(%%d+)")
local matchSilver = SILVER_AMOUNT:gsub("%%d", "(%%d+)")
local matchCopper = COPPER_AMOUNT:gsub("%%d", "(%%d+)")
local personalMoney = YOU_LOOT_MONEY:gsub("%%s", "(.+)")
local guildMoney = YOU_LOOT_MONEY_GUILD:gsub("%(", "%%("):gsub("%)", "%%)"):gsub("%%s", "(.+)")
local guildMoneyGroup = LOOT_MONEY_SPLIT_GUILD:gsub("%(", "%%("):gsub("%)", "%%)"):gsub("%%s", "(.+)")

local function getTotalFromString(msg)
	local g = (msg:match(matchGold) or 0) * 1000
	local s = (msg:match(matchSilver) or 0) * 100
	local c = msg:match(matchCopper) or 0
	return g + s + c
end

local function scanForGM()
	for i = 1, GetNumGuildMembers(true) do
		local n, _, r = GetGuildRosterInfo(i)
		if n and r == 0 then
			if n ~= pName then guildMaster = n end
			break
		end
	end
end

_G.SlashCmdList.BGMSlash = queryForMainCharacter
_G.SLASH_BGMSlash1 = "/bgmmain"

local haveWarnedThisSession = nil
local function broadcast(value)
	if not db.mainChar then
		if not haveWarnedThisSession then
			queryForMainCharacter()
			haveWarnedThisSession = true
		end
		return
	end
	SendAddonMessage(addonName, "1#" .. db.mainChar .. "#" .. tostring(value), "GUILD")
end

local function setup()
	BGM2DB = BGM2DB or {}
	if type(BGM2DB[guildName]) ~= "table" then
		BGM2DB[guildName] = {}
	end
	db = BGM2DB[guildName]
	for k, v in pairs({
		days = {}, -- Last 30 days, per-day generated income
		total = 0, -- Total value beyond the past 30 days is added up here
		others = {}, -- player:total values from the rest of the guild
		mainChar = nil, -- The name we broadcast to others
	}) do
		if type(db[k]) == "nil" then
			db[k] = v
		end
	end

	-- XXX
	-- Convert from old, fucked up DB - I started this addon with the
	-- vision that it'd be really simple and only storing each days value
	-- would be needed. But clearly it outgrew that vision.
	-- XXX remove after 2 releases or so
	if BGMDB then
		for guild, days in pairs(BGMDB) do
			if type(BGM2DB[guild]) ~= "table" then BGM2DB[guild] = {} end
			BGM2DB[guild].days = days
		end
		BGMDB = nil
	end
	if BGMTotalDB then
		for guild, total in pairs(BGMTotalDB) do
			if type(BGM2DB[guild]) ~= "table" then BGM2DB[guild] = {} end
			BGM2DB[guild].total = total
		end
		BGMTotalDB = nil
	end
	if BGMOthersDB then
		for guild, others in pairs(BGMOthersDB) do
			if type(BGM2DB[guild]) ~= "table" then BGM2DB[guild] = {} end
			BGM2DB[guild].others = others
		end
		BGMOthersDB = nil
	end
	if BGMSettingsDB then
		for guild, main in pairs(BGMSettingsDB.mainChar) do
			if type(BGM2DB[guild]) ~= "table" then BGM2DB[guild] = {} end
			BGM2DB[guild].mainChar = main
		end
		BGMSettingsDB = nil
	end
	-- XXX End conversion from old DB crap

	local c = ChatTypeInfo.GUILD
	if c then
		color = ("|cff%02x%02x%02x"):format(c.r * 255, c.g * 255, c.b * 255)
	end
	c = ChatTypeInfo.SYSTEM
	if c then
		sysColor = ("|cff%02x%02x%02x"):format(c.r * 255, c.g * 255, c.b * 255)
	end

	-- Borrowed from MoneyFu (probably ckk)
	local serverHour, serverMinute = GetGameTime()
	local utcHour = tonumber(date("!%H"))
	local utcMinute = tonumber(date("!%M"))
	local ser = serverHour + serverMinute / 60
	local utc = utcHour + utcMinute / 60
	local offset = floor((ser - utc) * 2 + 0.5) / 2
	if offset >= 12 then
		offset = offset - 24
	elseif offset < -12 then
		offset = offset + 24
	end
	today = floor((time() / 60 / 60 + offset) / 24)
	
	-- Anything older than 30 days is added to the total and reset
	local oneMonth = today - 30
	allTimeTotal = db.total
	for k, v in pairs(db.days) do
		allTimeTotal = allTimeTotal + v
		if k < oneMonth then
			db.total = db.total + v
			db.days[k] = nil
		end
	end
	if allTimeTotal > 0 then
		broadcast(allTimeTotal)
	end

	scanForGM()
	updateText()
	bGuildMoney.OnTooltipShow = updateTooltip
end

local function attemptToSetup()
	if guildName then return true end
	guildName = GetGuildInfo("player")
	if not guildName then return end
	setup()
	return true
end

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("GUILD_ROSTER_UPDATE")
f:RegisterEvent("CHAT_MSG_ADDON")
f:SetScript("OnEvent", function(self, event, addon, message, channel, sender)
	if event == "PLAYER_LOGIN" or event == "PLAYER_ENTERING_WORLD" then
		if attemptToSetup() then
			self:UnregisterEvent("PLAYER_LOGIN")
			self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		else
			self:RegisterEvent("PLAYER_ENTERING_WORLD")
		end
	elseif event == "GUILD_ROSTER_UPDATE" then
		attemptToSetup()
		scanForGM()
	elseif event == "CHAT_MSG_ADDON" then
		if addon ~= addonName or sender == pName then return end
		-- Apparently CHAT_MSG_ADDON can arrive before ADDON_LOADED, so lets go.
		if not db then return end
		local version, player, total = strsplit("#", message)
		if tonumber(version) ~= 1 or not player or not total then return end
		local v = tonumber(total)
		if not v or v < 1 then return end
		db.others[player] = v
	end
end)

local function filter(self, event, msg, ...)
	-- |not db| catches failed startup
	if not db then return end
	local personal, guild = msg:match(guildMoney)
	if not guild or GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0 then
		personal, guild = msg:match(guildMoneyGroup)
	end
	if not guild then return end

	local looted = (getTotalFromString(guild) or 0)
	sessionTotal = sessionTotal + looted
	db.days[today] = (db.days[today] or 0) + looted
	allTimeTotal = allTimeTotal + looted

	local t = GetTime()
	if not lastTransmitTime or (t > lastTransmitTime + 120) then
		broadcast(allTimeTotal)
		lastTransmitTime = t
	end

	updateText()

	local t = GetCoinTextureString(getTotalFromString(personal))
	return false, YOU_LOOT_MONEY:format(t) .. ".", ...
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_MONEY", filter)

